diff --git a/gcc/final.c b/gcc/final.c
index f6974f4..4309ccb 100644
--- a/gcc/final.c
+++ b/gcc/final.c
@@ -795,25 +795,35 @@ compute_alignments (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_compute_alignments =
+class pass_compute_alignments : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "alignments",                         /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  compute_alignments,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing               /* todo_flags_finish */
- }
-};
+public:
+  pass_compute_alignments(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "alignments",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return compute_alignments (); }
+
+}; // class pass_compute_alignments
+
+rtl_opt_pass *
+make_pass_compute_alignments (context &ctxt)
+{
+  return new pass_compute_alignments (ctxt);
+}
 
 
 /* Make a pass over all insns and compute their actual lengths by shortening
@@ -4379,25 +4389,35 @@ rest_of_handle_final (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_final =
+class pass_final : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "final",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_final,                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_FINAL,                             /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_final(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "final",
+		   OPTGROUP_NONE,
+		   TV_FINAL,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_final (); }
+
+}; // class pass_final
+
+rtl_opt_pass *
+make_pass_final (context &ctxt)
+{
+  return new pass_final (ctxt);
+}
 
 
 static unsigned int
@@ -4408,25 +4428,37 @@ rest_of_handle_shorten_branches (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_shorten_branches =
+class pass_shorten_branches : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "shorten",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_shorten_branches,      /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_SHORTEN_BRANCH,                    /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_shorten_branches(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "shorten",
+		   OPTGROUP_NONE,
+		   TV_SHORTEN_BRANCH,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_shorten_branches ();
+  }
+
+}; // class pass_shorten_branches
+
+rtl_opt_pass *
+make_pass_shorten_branches (context &ctxt)
+{
+  return new pass_shorten_branches (ctxt);
+}
 
 
 static unsigned int
@@ -4555,22 +4587,32 @@ rest_of_clean_state (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_clean_state =
+class pass_clean_state : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "*clean_state",                       /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_clean_state,                  /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_FINAL,                             /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  PROP_rtl,                             /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_clean_state(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*clean_state",
+		   OPTGROUP_NONE,
+		   TV_FINAL,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(PROP_rtl)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_clean_state (); }
+
+}; // class pass_clean_state
+
+rtl_opt_pass *
+make_pass_clean_state (context &ctxt)
+{
+  return new pass_clean_state (ctxt);
+}
diff --git a/gcc/function.c b/gcc/function.c
index 36c874f..5d022b2 100644
--- a/gcc/function.c
+++ b/gcc/function.c
@@ -1948,25 +1948,35 @@ instantiate_virtual_regs (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_instantiate_virtual_regs =
-{
- {
-  RTL_PASS,
-  "vregs",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  instantiate_virtual_regs,             /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_instantiate_virtual_regs : public rtl_opt_pass
+{
+public:
+  pass_instantiate_virtual_regs(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "vregs",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return instantiate_virtual_regs (); }
+
+}; // class pass_instantiate_virtual_regs
+
+rtl_opt_pass *
+make_pass_instantiate_virtual_regs (context &ctxt)
+{
+  return new pass_instantiate_virtual_regs (ctxt);
+}
 
 
 /* Return 1 if EXP is an aggregate type (or a value with aggregate type).
@@ -6944,25 +6954,37 @@ types_used_by_var_decl_insert (tree type, tree var_decl)
     }
 }
 
-struct rtl_opt_pass pass_leaf_regs =
-{
- {
-  RTL_PASS,
-  "*leaf_regs",                         /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_check_leaf_regs,       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_leaf_regs : public rtl_opt_pass
+{
+public:
+  pass_leaf_regs(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*leaf_regs",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_check_leaf_regs ();
+  }
+
+}; // class pass_leaf_regs
+
+rtl_opt_pass *
+make_pass_leaf_regs (context &ctxt)
+{
+  return new pass_leaf_regs (ctxt);
+}
 
 static unsigned int
 rest_of_handle_thread_prologue_and_epilogue (void)
@@ -6983,26 +7005,37 @@ rest_of_handle_thread_prologue_and_epilogue (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_thread_prologue_and_epilogue =
-{
- {
-  RTL_PASS,
-  "pro_and_epilogue",                   /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_thread_prologue_and_epilogue, /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_THREAD_PROLOGUE_AND_EPILOGUE,      /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  TODO_verify_flow,                     /* todo_flags_start */
-  TODO_df_verify | TODO_df_finish
-  | TODO_verify_rtl_sharing             /* todo_flags_finish */
- }
-};
+class pass_thread_prologue_and_epilogue : public rtl_opt_pass
+{
+public:
+  pass_thread_prologue_and_epilogue(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "pro_and_epilogue",
+		   OPTGROUP_NONE,
+		   TV_THREAD_PROLOGUE_AND_EPILOGUE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(TODO_verify_flow),
+				   finish(TODO_df_verify | TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_thread_prologue_and_epilogue ();
+  }
+
+}; // class pass_thread_prologue_and_epilogue
+
+rtl_opt_pass *
+make_pass_thread_prologue_and_epilogue (context &ctxt)
+{
+  return new pass_thread_prologue_and_epilogue (ctxt);
+}
 
 
 /* This mini-pass fixes fall-out from SSA in asm statements that have
@@ -7184,25 +7217,35 @@ rest_of_match_asm_constraints (void)
   return TODO_df_finish;
 }
 
-struct rtl_opt_pass pass_match_asm_constraints =
-{
- {
-  RTL_PASS,
-  "asmcons",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  rest_of_match_asm_constraints,	/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_match_asm_constraints : public rtl_opt_pass
+{
+public:
+  pass_match_asm_constraints(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "asmcons",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_match_asm_constraints (); }
+
+}; // class pass_match_asm_constraints
+
+rtl_opt_pass *
+make_pass_match_asm_constraints (context &ctxt)
+{
+  return new pass_match_asm_constraints (ctxt);
+}
 
 
 #include "gt-function.h"
diff --git a/gcc/fwprop.c b/gcc/fwprop.c
index 17cc62a..bf4be58 100644
--- a/gcc/fwprop.c
+++ b/gcc/fwprop.c
@@ -1485,27 +1485,35 @@ fwprop (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_fwprop =
+class pass_rtl_fwprop : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "fwprop1",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_fwprop,				/* gate */
-  fwprop,				/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_FWPROP,                            /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish
-    | TODO_verify_flow
-    | TODO_verify_rtl_sharing           /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_fwprop(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "fwprop1",
+		   OPTGROUP_NONE,
+		   TV_FWPROP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_flow | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_fwprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return fwprop (); }
+
+}; // class pass_rtl_fwprop
+
+rtl_opt_pass *
+make_pass_rtl_fwprop (context &ctxt)
+{
+  return new pass_rtl_fwprop (ctxt);
+}
 
 static unsigned int
 fwprop_addr (void)
@@ -1535,22 +1543,32 @@ fwprop_addr (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_fwprop_addr =
+class pass_rtl_fwprop_addr : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "fwprop2",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_fwprop,				/* gate */
-  fwprop_addr,				/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_FWPROP,                            /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing  /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_fwprop_addr(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "fwprop2",
+		   OPTGROUP_NONE,
+		   TV_FWPROP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_fwprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return fwprop_addr (); }
+
+}; // class pass_rtl_fwprop_addr
+
+rtl_opt_pass *
+make_pass_rtl_fwprop_addr (context &ctxt)
+{
+  return new pass_rtl_fwprop_addr (ctxt);
+}
diff --git a/gcc/gcse.c b/gcc/gcse.c
index e1daf18..42c2fba 100644
--- a/gcc/gcse.c
+++ b/gcc/gcse.c
@@ -4131,46 +4131,64 @@ execute_rtl_hoist (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_pre =
+class pass_rtl_pre : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "rtl pre",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_rtl_pre,                         /* gate */
-  execute_rtl_pre,    			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_PRE,                               /* tv_id */
-  PROP_cfglayout,                       /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_pre(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "rtl pre",
+		   OPTGROUP_NONE,
+		   TV_PRE,
+		   pass_properties(required(PROP_cfglayout),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_pre (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_rtl_pre (); }
+
+}; // class pass_rtl_pre
+
+rtl_opt_pass *
+make_pass_rtl_pre (context &ctxt)
+{
+  return new pass_rtl_pre (ctxt);
+}
 
-struct rtl_opt_pass pass_rtl_hoist =
+class pass_rtl_hoist : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "hoist",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_rtl_hoist,                       /* gate */
-  execute_rtl_hoist,  			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_HOIST,                             /* tv_id */
-  PROP_cfglayout,                       /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_hoist(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "hoist",
+		   OPTGROUP_NONE,
+		   TV_HOIST,
+		   pass_properties(required(PROP_cfglayout),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_hoist (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_rtl_hoist (); }
+
+}; // class pass_rtl_hoist
+
+rtl_opt_pass *
+make_pass_rtl_hoist (context &ctxt)
+{
+  return new pass_rtl_hoist (ctxt);
+}
 
 #include "gt-gcse.h"
diff --git a/gcc/gimple-low.c b/gcc/gimple-low.c
index b06d194..17bf830 100644
--- a/gcc/gimple-low.c
+++ b/gcc/gimple-low.c
@@ -177,25 +177,35 @@ lower_function_body (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_lower_cf =
+class pass_lower_cf : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "lower",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  lower_function_body,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_gimple_any,			/* properties_required */
-  PROP_gimple_lcf,			/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+public:
+  pass_lower_cf(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "lower",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(PROP_gimple_lcf),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return lower_function_body (); }
+
+}; // class pass_lower_cf
+
+gimple_opt_pass *
+make_pass_lower_cf (context &ctxt)
+{
+  return new pass_lower_cf (ctxt);
+}
 
 
 
diff --git a/gcc/gimple-ssa-strength-reduction.c b/gcc/gimple-ssa-strength-reduction.c
index 57b343a..da8d4fa 100644
--- a/gcc/gimple-ssa-strength-reduction.c
+++ b/gcc/gimple-ssa-strength-reduction.c
@@ -2688,22 +2688,32 @@ gate_strength_reduction (void)
   return flag_tree_slsr;
 }
 
-struct gimple_opt_pass pass_strength_reduction =
-{
- {
-  GIMPLE_PASS,
-  "slsr",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_strength_reduction,		/* gate */
-  execute_strength_reduction,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_GIMPLE_SLSR,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+class pass_strength_reduction : public gimple_opt_pass
+{
+public:
+  pass_strength_reduction(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "slsr",
+		      OPTGROUP_NONE,
+		      TV_GIMPLE_SLSR,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_strength_reduction (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_strength_reduction (); }
+
+}; // class pass_strength_reduction
+
+gimple_opt_pass *
+make_pass_strength_reduction (context &ctxt)
+{
+  return new pass_strength_reduction (ctxt);
+}
diff --git a/gcc/ifcvt.c b/gcc/ifcvt.c
index 4057577..d253964 100644
--- a/gcc/ifcvt.c
+++ b/gcc/ifcvt.c
@@ -4462,26 +4462,35 @@ rest_of_handle_if_conversion (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_ifcvt =
+class pass_rtl_ifcvt : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "ce1",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_if_conversion,            /* gate */
-  rest_of_handle_if_conversion,         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_IFCVT,                             /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_ifcvt(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "ce1",
+		   OPTGROUP_NONE,
+		   TV_IFCVT,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_if_conversion (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_if_conversion (); }
+
+}; // class pass_rtl_ifcvt
+
+rtl_opt_pass *
+make_pass_rtl_ifcvt (context &ctxt)
+{
+  return new pass_rtl_ifcvt (ctxt);
+}
 
 static bool
 gate_handle_if_after_combine (void)
@@ -4500,25 +4509,37 @@ rest_of_handle_if_after_combine (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_if_after_combine =
+class pass_if_after_combine : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "ce2",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_if_after_combine,         /* gate */
-  rest_of_handle_if_after_combine,      /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_IFCVT,                             /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_if_after_combine(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "ce2",
+		   OPTGROUP_NONE,
+		   TV_IFCVT,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_if_after_combine (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_if_after_combine ();
+  }
+
+}; // class pass_if_after_combine
+
+rtl_opt_pass *
+make_pass_if_after_combine (context &ctxt)
+{
+  return new pass_if_after_combine (ctxt);
+}
 
 
 static bool
@@ -4536,22 +4557,34 @@ rest_of_handle_if_after_reload (void)
 }
 
 
-struct rtl_opt_pass pass_if_after_reload =
+class pass_if_after_reload : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "ce3",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_if_after_reload,          /* gate */
-  rest_of_handle_if_after_reload,       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_IFCVT2,                            /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_if_after_reload(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "ce3",
+		   OPTGROUP_NONE,
+		   TV_IFCVT2,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_if_after_reload (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_if_after_reload ();
+  }
+
+}; // class pass_if_after_reload
+
+rtl_opt_pass *
+make_pass_if_after_reload (context &ctxt)
+{
+  return new pass_if_after_reload (ctxt);
+}
diff --git a/gcc/init-regs.c b/gcc/init-regs.c
index 270d39b..6363944 100644
--- a/gcc/init-regs.c
+++ b/gcc/init-regs.c
@@ -138,22 +138,34 @@ rest_of_handle_initialize_regs (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_initialize_regs =
+class pass_initialize_regs : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "init-regs",                          /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_initialize_regs,                 /* gate */
-  rest_of_handle_initialize_regs,       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish                        /* todo_flags_finish */
- }
-};
+public:
+  pass_initialize_regs(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "init-regs",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_initialize_regs (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_initialize_regs ();
+  }
+
+}; // class pass_initialize_regs
+
+rtl_opt_pass *
+make_pass_initialize_regs (context &ctxt)
+{
+  return new pass_initialize_regs (ctxt);
+}
